﻿@{
    ViewData["Title"] = "Adviser List";
}
<div class="container">
    <div class="card">
        <div class="card-body">
            <div class="tab-content">
                <div id="firm-adviser-list">
                    <div class="d-flex flex-row-reverse">
                        <div class="mr-5">
                            <button onclick="$('#FirmAdviserAdvanceFilterModal').modal({ backdrop: 'static' });" class="btn btn-outline-dark btn-hover-light-dark" id="btn-advance-filter" style="padding: 9.5px 15px;" data-toggle="tooltip" title="Click here to Advance Search"><i class="fas fa-filter p-0"></i></button>
                        </div>
                    </div>
                    <div class="datatable datatable-bordered" id="firm_list"></div>
                </div>
                <div id="filtered-firm-adviser-list" class="d-none">
                    <button onclick="toggleDiv();window['datatable'].reload();" class="btn btn-sm btn-icon btn-outline-primary btn-hover-light-primary btn-circle" data-toggle="tooltip" title="Back to Default View" id="btn-nav-back">
                        <i class="fas fa-arrow-left"></i>
                    </button>
                    <div class="datatable datatable-bordered" id="adviser-list"></div>
                </div>
            </div>
        </div>
    </div>
</div>
<div class="modal" id="AdviserModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true"></div>
<partial name="_AdviserAdvanceSearchModal" />
@section scripts{
    <script>
        $(document).on("click", ".btn-adviser-add,.btn-adviser-edit", function () {
            KTApp.blockPage({ overlayColor: '#000000', state: 'primary', message: 'Please wait...' });
            var guid = $(this).attr("data-guid");
            loadPartialView(`admin/adviser/addadviser?guid=${guid}`, "AdviserModal");
            setTimeout(function () { KTApp.unblockPage(); }, 1000);
            $("#AdviserModal").modal({ backdrop: 'static' });
        });
        var adviserTable = function (e) {
            var id = e.data.id;
            var ktDataTablOptions = ktDataTableDefaultConfigOptions;
            ktDataTablOptions.source = `admin/superadmin/fetchadvisers?firmId=${id}`;
            window['sub_datatable_' + id] = $('<div/>').attr('id', `firm_list_${id}`).appendTo(e.detailCell).KTDatatable({
                data: ktDataTablOptions,
                columnFilter: true,
                columns: [
                    { field: 'id', title: '#', width: 85, filter: { maxlength: 5, additionalClasses: "numericOnly-no-placeholder" } },
                    {
                        field: 'userData.name', sortable: 'asc', title: 'Name/Email', width: 330, filter: { container: "AdviserName" },
                        template: function (row) {
                            var isSetupCompleted = row.setupCompletedDate != null && row.setupCompletedDate.length > 2
                            var initial = [row.userData.firstName, row.userData.lastName].map((n) => n[0]).join("").substring(0, 2);
                            var color = getRandomColor();
                            var hasDob = row.userData.dateOfBirth != null && new Date(row.userData.dateOfBirth).getFullYear() != 1;
                            //var html = row.isAssistant ? '<span class="label label-inline label-info font-weight-bold ml-2">Assistant</span>' : '';
                            var tooltipHtml = "Pending Items To Complete";
                            tooltipHtml += "<ul>";
                            if (!isSetupCompleted)
                                tooltipHtml += `<li>Password setup process</li>`;
                            if (!hasDob)
                                tooltipHtml += `<li>Date of Birth</li>`;
                            if (!row.adviserContactInfo)
                                tooltipHtml += `<li>Contact Information</li>`;
                            if (!row.userData.riaId)
                                tooltipHtml += `<li>Select RIA</li>`;
                            tooltipHtml += "</ul>";
                            var warningHtml = !(hasDob || row.adviserContactInfo || row.userData.riaId > 0) ?
                                `<span class="fa-stack pulse pulse-warning ml-2" data-toggle="tooltip" data-html="true" data-original-title="${tooltipHtml}" data-placement="right" role = "button" >
                                                                                <i class="fas fa-play fa-stack-1x text-dark icon-nm" style="transform: rotate(30deg);left:1px;top:3px"></i>
                                                                                <i class="fas fa-exclamation-triangle fa-stack-1x text-warning"></i>
                                                                                <span class="pulse-ring" style="margin-left:-4px;margin-top:-5px"></span>
                                                                            </span>` : '';
                            return `<div class="d-flex align-items-center">
                                                                                    <div class="symbol symbol-40 flex-shrink-0">
                                                                                         <div class="symbol-label text-white" style="background:${color}">${initial}</div>
                                                                                    </div>
                                                                                    <div class="ml-2">
                                                                                        <div class="text-dark-75 font-weight-bold line-height-sm">${row.userData.name}</div>
                                                                                        <div class="text-primary">${row.username}</div>
                                                                                    </div>
                                                                                    ${warningHtml}
                                                                                </div>`;
                        }
                    },
                    {
                        field: 'roles', title: 'Roles', sortable: false, width: 190, filter: { filterType: "multiselect", additionalClasses: `roles-filter-dropdown-${id}` },
                        template: function (row) {
                            var label_class = "";
                            label_class = row.adminRole == AdminRoleEnum.FIRMPRINCIPAL ? "dark" : row.adminRole == AdminRoleEnum.FIRMADMIN ? "warning" : row.adminRole == AdminRoleEnum.COMPLIANCE ? "info" : "success";
                            var html = `<span class="label label-outline-${label_class} label-inline mr-2 mb-2 font-weight-bold">${row.adminRoleString}</span>`;
                            row.permissions.forEach(function (item) {
                                label_class = item.roleType == AdminRoleEnum.FIRMADMIN ? "warning" : item.roleType == AdminRoleEnum.COMPLIANCE ? "info" : "success";
                                html += `<span class="label label-${label_class} label-inline mr-2 mb-2">${item.roleTypeString}</span>`;
                            })
                            return html;
                        }
                    },
                    {
                        field: 'setupCompletedDate', title: 'Password&nbsp;Setup', sortable: false, width: 125,
                        template: function (row) {
                            return getDataTableDateWithHtml(row.setupCompletedDate)
                        },
                    },
                    {
                        field: 'lastLogin', title: 'Last Login', sortable: false, width: 80,
                        template: function (row) {
                            return getDataTableDateWithHtml(row.lastLogin)
                        }
                    },
                    {
                        field: 'actions', title: 'Actions', width: 150, sortable: false, overflow: 'visible',
                        template: function (row) {
                            var isSetupCompleted = row.setupCompletedDate != null && new Date(row.setupCompletedDate).getFullYear() != 1;
                            var hasDob = row.userData.dateOfBirth != null && new Date(row.userData.dateOfBirth).getFullYear() != 1;
                            var isValidAdv2B = hasDob && row.adviserContactInfos.length && row.userData.riaId > 0;
                            var tz = new Date().getTimezoneOffset();
                            var resend_html = !isSetupCompleted ?
                                `<button class="btn btn-sm btn-icon resend-invitation-button" data-toggle="tooltip" data-original-title="Resend Invitation" onclick="reinvite(this,${AdminRoleEnum.ADVISER},'${row.guid}')">
                                                                         <img src="/images/email-resend-icon.png" height="25" />
                                                                         <i class="fa fa-redo text-warning icon-sm resend-invitation-icon" aria-hidden="true" style="left: 64px;top: 29px;"></i>
                                                                     </button>` : "";
                            var adv2bHtml = isValidAdv2B ?
                                `<a href="adviser/adv-2b?token=${encodeURIComponent(row.encryptedGuid)}&tz=${tz}" target="_blank" class="btn btn-sm btn-icon" data-toggle="tooltip" data-original-title="ADV 2B">
                                                                         <i class="far fa-file-alt icon-2x text-primary icon-xl" aria-hidden="true"></i>
                                                                     </a>` : "";
                            var viewProfileHtml = isSetupCompleted ?
                                `<a class="ml-1" href="admin/account/adviserlogin?guid=${row.guid}" target="_blank" data-toggle="tooltip" data-original-title="View Profile">
                                                                            <img src="/images/view-profile.png" height="30" />
                                                                         </a>` : "";
                            return `${viewProfileHtml}
                                                                        <button class="btn btn-sm btn-icon ml-2 btn-adviser-edit" data-toggle="tooltip" data-original-title="Edit" data-guid="${row.guid}">
                                                                              <img src="/images/edit-icon.png" height="25" />
                                                                        </button>
                                                                        ${resend_html}
                                                                        ${adv2bHtml}`;
                        },
                    }
                ],
            })
            $(`#firm_list_${id}`).on('datatable-on-init', function (e, data) {
                bindRolesDropdown(id);
            });
        }
        bindFirmsGrid("Adviser", adviserTable);

        $(document).on("click", "#btn-advance-filter-submit", function () {
            if (!$("#FirmId-Filter").val() && !$("#Id").val() && !$("#AdviserName").val() && !$("#Roles").val().toString()) {
                _showFormMessage("advance-filter-frm", "danger", "Please insert at least one search criteria", "fas fa-exclamation-triangle");
                return;
            }
            $(".alert").remove();
            bindAdvanceSearchFirmAdviserList();
            $(`#FirmAdviserAdvanceFilterModal`).modal('hide');
            $("#btn-nav-back").removeClass("d-none");
            $(".nav-item .nav-link").eq(1).click();
        });
        var bindAdvanceSearchFirmAdviserList = function () {
            if ($('#adviser-list').html() != '')
                window['datatable-firm-adviser-list'].destroy();
            toggleDiv();
            var ktDataTablOptions2 = ktDataTableDefaultConfigOptions;
            var roles = $("#Roles").val().toString();
            ktDataTablOptions2.source = {
                read: {
                    url: `admin/superadmin/fetchadvisers?role=${AdminRoleEnum.ADVISER}`,
                    params: {
                        query:
                        {
                            FirmId: $("#FirmId-Filter").val(),
                            Id: $("#Id").val(),
                            AdviserName: $("#AdviserName").val(),
                            Roles: roles ? roles : AdminRoleEnum.ADVISER.toString()
                        }
                    }
                }
            };

            window['datatable-firm-adviser-list'] = $('#adviser-list').KTDatatable({
                data: ktDataTablOptions2,
                columns: [
                    { field: 'id', title: '#', width: 30 },
                    {
                        field: 'userData.name',sortable: 'asc', title: 'Name', width: 330,
                        template: function (row) {
                            var isValidDate = row.setupCompletedDate != null && row.setupCompletedDate.length > 2
                            var initial = [row.userData.firstName, row.userData.lastName].map((n) => n[0]).join("").substring(0, 2);
                            var color = getRandomColor();
                            //var html = row.isAssistant ? '<span class="label label-inline label-info font-weight-bold ml-2">Assistant</span>' : '';
                            var warningHtml = !isValidDate ?
                                `<span class="fa-stack pulse pulse-warning ml-2" data-toggle="tooltip" data-html="true" data-original-title="Complete the Password setup process" data-placement="right" role = "button" >
                                                                                <i class="fas fa-play fa-stack-1x text-dark icon-nm" style="transform: rotate(30deg);left:1px;top:3px"></i>
                                                                                <i class="fas fa-exclamation-triangle fa-stack-1x text-warning"></i>
                                                                                <span class="pulse-ring" style="margin-left:-4px;margin-top:-5px"></span>
                                                                            </span>` : '';
                            return `<div class="d-flex align-items-center">
                                                                                    <div class="symbol symbol-40 flex-shrink-0">
                                                                                         <div class="symbol-label text-white" style="background:${color}">${initial}</div>
                                                                                    </div>
                                                                                    <div class="ml-2">
                                                                                        <div class="text-dark-75 font-weight-bold line-height-sm">${row.userData.name}</div>
                                                                                        <div class="text-primary">${row.username}</div>
                                                                                    </div>
                                                                                    ${warningHtml}
                                                                                </div>`;
                        }
                    },
                    {
                        field: 'roles', title: 'Roles', sortable: false, width: 190,
                        template: function (row) {
                            var label_class = "";
                            label_class = row.adminRole == AdminRoleEnum.FIRMPRINCIPAL ? "dark" : row.adminRole == AdminRoleEnum.FIRMADMIN ? "warning" : row.adminRole == AdminRoleEnum.COMPLIANCE ? "info" : "success";
                            var html = `<span class="label label-outline-${label_class} label-inline mr-2 mb-2 font-weight-bold">${row.adminRoleString}</span>`;
                            row.permissions.forEach(function (item) {
                                label_class = item.roleType == AdminRoleEnum.FIRMADMIN ? "warning" : item.roleType == AdminRoleEnum.COMPLIANCE ? "info" : "success";
                                html += `<span class="label label-${label_class} label-inline mr-2 mb-2">${item.roleTypeString}</span>`;
                            })
                            return html;
                        }
                    },
                    {
                        field: 'firm.name', title: 'Firm Name', width: 125
                    },
                    {
                        field: 'setupCompletedDate', title: 'Password&nbsp;Setup', sortable: false, width: 125,
                        template: function (row) {
                            return getDataTableDateWithHtml(row.setupCompletedDate)
                        },
                    },
                    {
                        field: 'lastLogin', title: 'Last Login', sortable: false, width: 80,
                        template: function (row) {
                            return getDataTableDateWithHtml(row.lastLogin)
                        }
                    },
                    {
                        field: 'actions', title: 'Actions', width: 100, sortable: false, overflow: 'visible',
                        template: function (row) {
                            var isSetupCompleted = row.setupCompletedDate != null && new Date(row.setupCompletedDate).getFullYear() != 1;
                            var resend_html = !isSetupCompleted ? `<button class="btn btn-sm btn-icon resend-invitation-button" data-toggle="tooltip" data-original-title="Resend Invitation" onclick="reinvite(this,${AdminRoleEnum.ADVISER},'${row.guid}')">
                                                                                            <img src="/images/email-resend-icon.png" height="25" />
                                                                                            <i class="fa fa-redo text-warning icon-sm resend-invitation-icon" aria-hidden="true" style="left: 64px;top: 29px;"></i>
                                                                                        </button>` : "";
                            return `<button class="btn btn-sm btn-icon ml-2 btn-adviser-edit" data-toggle="tooltip" data-original-title="Edit" data-guid="${row.guid}">
                                                                                                              <img src="/images/edit-icon.png" height="25" />
                                                                                                        </button>
                                                                                                        ${resend_html}`;
                        },
                    }
                ],
            })
        }

        var toggleDiv = function () {
            $("#firm-adviser-list").toggleClass("d-none");
            $("#filtered-firm-adviser-list").toggleClass("d-none");
        }

        $('#FirmAdviserAdvanceFilterModal').on('hidden.bs.modal', function (e) {
            $(e.currentTarget).find("input").val("");
            $(e.currentTarget).find("select").val("").trigger("change");
        });
        bindFirmDropdown("FirmId-Filter");
        bindPermissionMultiselect2("Roles");
    </script>
}